]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- macros for using sequental patches (f.e: vim)
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
35 %__gtkdocize            gtkdocize --copy
36 %__intltoolize          intltoolize --copy --force
37 %__libtoolize           libtoolize --copy --force
38
39 #       The number of cvs changelog entries kept when building package.
40 %_buildchangelogtruncate 20
41
42 %dependencytracking     %{nil}
43
44 #       Relations between package names that cause dependency loops
45 #       with legacy packages that cannot be fixed. Relations are
46 #       specified as
47 #               p>q
48 #       where package p has a Requires: on something that package q Provides:
49 #
50 # XXX   Note: that there cannot be any whitespace within the string "p>q",
51 #       and that both p and q are package names (i.e. no version/release).
52 %_dependency_whiteout   %{nil}
53
54
55 #-----------------------------------------------------------------
56 #
57 # (re)definition of %{rpm*flags} with %filterout_* support
58 # Requires:             awk
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i in I) {  A=0;                    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
116  %{?__cc:CC="%{__cc}" ; export CC ; } \
117  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
118  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
119         --host=%{_target_platform} \
120         --prefix=%{_prefix} \
121         --exec-prefix=%{_exec_prefix} \
122         --bindir=%{_bindir} \
123         --sbindir=%{_sbindir} \
124         --sysconfdir=%{_sysconfdir} \
125         --datadir=%{_datadir} \
126         --includedir=%{_includedir} \
127         --libdir=%{_libdir} \
128         --libexecdir=%{_libexecdir} \
129         --localstatedir=%{_localstatedir} \
130         --sharedstatedir=%{_sharedstatedir} \
131         --mandir=%{_mandir} \
132         --infodir=%{_infodir} \
133         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
134         %{dependencytracking} \
135 }
136
137 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
138 %__cmake        /usr/bin/cmake
139 %cmake { \
140 CC="%{__cc}" \
141 CXX="%{__cxx}" \
142 CFLAGS="%{rpmcflags}" \
143 CXXFLAGS="%{rpmcxxflags}" \
144 %{__cmake} \
145 }
146
147 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
148 %__scons        /usr/bin/scons
149 %scons { \
150 %{__scons} \
151 }
152
153 # waf. see waf.spec
154 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
155 %__waf  /usr/bin/waf
156 %waf { \
157 CC="%{__cc}" \
158 CXX="%{__cxx}" \
159 CPP="%{__cpp}" \
160 CFLAGS="%{rpmcflags}" \
161 CXXFLAGS="%{rpmcxxflags}" \
162 %{__waf} \
163 }
164
165 #----------------------------------------------------------------
166 %global configure_cache 0
167 %configure_cache_file   %{buildroot}.configure.cache
168
169 %configure {./configure \
170         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
171         CFLAGS="${CFLAGS:-%rpmcflags}" \
172         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
173         FFLAGS="${FFLAGS:-%rpmcflags}" \
174         CPPFLAGS="${CPPFLAGS:-}" \
175         %{?__cc:CC="%{__cc}"} \
176         %{?__cxx:CXX="%{__cxx}"} \
177         --host=%{_target_platform} \
178         --build=%{_target_platform} \
179         --prefix=%{_prefix} \
180         --exec-prefix=%{_exec_prefix} \
181         --bindir=%{_bindir} \
182         --sbindir=%{_sbindir} \
183         --sysconfdir=%{_sysconfdir} \
184         --datadir=%{_datadir} \
185         --includedir=%{_includedir} \
186         --libdir=%{_libdir} \
187         --libexecdir=%{_libexecdir} \
188         --localstatedir=%{_localstatedir} \
189         --sharedstatedir=%{_sharedstatedir} \
190         --mandir=%{_mandir} \
191         --infodir=%{_infodir} \
192         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
193         %{dependencytracking} \
194         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
195 }
196
197 # ------------------------------------------------------------------------
198 # Overloading of some basic macros
199 %prep \
200 %%prep\
201 export LC_ALL=C\
202 export LANG=C\
203 unset LINGUAS ||:\
204 unset LANGUAGE ||:\
205 unset LC_MESSAGES ||:\
206 unset DISPLAY ||:\
207 %{nil}
208
209 %build %%build\
210 export LC_ALL=C\
211 export LANG=C\
212 unset LINGUAS ||:\
213 unset LANGUAGE ||:\
214 unset LC_MESSAGES ||:\
215 unset DISPLAY ||:\
216 %{nil}
217
218 %install \
219 %if 0%{?_enable_debug_packages}\
220 %{?buildsubdir:%{debug_package}}\
221 %endif\
222 %%install\
223 export LC_ALL=C\
224 export LANG=C\
225 unset LINGUAS ||:\
226 unset LANGUAGE ||:\
227 unset LC_MESSAGES ||:\
228 unset DISPLAY ||:\
229 %{nil}
230
231 # Location of autoconf macros
232 %_aclocaldir    %(aclocal --print-ac-dir)
233
234 # Location of omf files
235 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
236
237 # Location of pkgconfig files
238 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
239
240 # Location of desktop files
241 %_desktopdir    /usr/share/applications
242 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
243
244 # Location of pixmaps for applnk/desktop files
245 %_pixmapsdir    /usr/share/pixmaps
246
247 # Location of themable icons for applnk/desktop files
248 %_iconsdir      /usr/share/icons
249
250 # Location of fonts directories
251 %_fontsdir      /usr/share/fonts
252
253 # Location of Gtk and associated libraries documentation
254 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
255
256 # Location of KDE documentation
257 %_kdedocdir     %{_defaultdocdir}/kde/HTML
258
259 # unsermake script
260 %__unsermake /usr/share/unsermake/unsermake
261
262 # Current date
263 %date           %(LC_ALL="C" date +"%a %b %d %Y")
264
265 # tmp directory
266 %tmpdir         %(echo "${TMPDIR:-/tmp}")
267
268 # Example files, programs, scripts...
269 %_examplesdir   /usr/src/examples
270
271 # Alternative kernel type/version
272 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
273
274 # The directory holding Linux kernel sources
275 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
276
277 # If non-empty "debug" macro defined, add "dbg" suffix to release number
278 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
279
280 # Requires name = version-release
281 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
282
283 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
284 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
285 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
286 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
287
288 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
289 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
290
291 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
292
293 # kernel version-release handling
294 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
295 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
296 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
297 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
298 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
299
300 # sgml macros
301 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
302 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
303 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
304 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
305 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
306 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
307 %docbook_sgmlcat_fix() { for l in \
308 '' \
309 '  -- default decl --' \
310 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
311 '  -- hacks for opensp --' \
312 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
313 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
314 '' \
315 ; do echo $l; done >> %1 \
316 }
317
318 # minimum file size needed for compressed documents.
319 # just smaller files than this get larger when compressed.
320 # some stats:
321 # - 0 byte file compressed was 25 bytes .gz
322 # - 39 byte file was compressed as 57
323 # - with test/test.spec@man 158 byte file was compressed also 158
324 %_min_compress_bytes    159
325
326 #-----------------------------------------------------------------
327 # find and gzip all files in %{_mandir} and %{infodir}
328 #
329 # Requires: xargs, find
330 #
331 #%no_install_post_compress_docs 1
332 %__spec_install_post_compress_docs { \
333 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
334         echo "Compress man and info pages."; \
335         for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
336                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
337                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
338                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
339                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
340                 fi; \
341         done; \
342 }; __spec_install_post_compress_docs } }
343
344 #-----------------------------------------------------------------
345 # Strip executable binaries and shared object files
346 #
347 # Requires: find, awk, strip, cut, xargs
348 #
349 #%no_install_post_strip 1
350 %__spec_install_post_strip {%{!?debug: \
351 %{!?no_install_post_strip:__spec_install_post_strip() { \
352         if [ -d "$RPM_BUILD_ROOT" ]; then \
353         echo "Strip executable binaries, archives and shared object files."; \
354         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
355         printf "Considering %d files\n" $(echo "$filelist" | wc -l); \
356         filetypes=`echo $filelist | xargs -r file` \
357         elfexelist=`echo "$filetypes" | awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
358         elfsharedlist=`echo "$filetypes" | awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
359         archiveslist=`echo "$filetypes" | awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
360         if [ -n "$elfexelist" ]; then \
361                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
362                 chmod u+w $elfexelist; \
363                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
364                 echo "DONE"; \
365         fi; \
366         if [ -n "$elfsharedlist" ]; then \
367                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
368                 chmod u+w $elfsharedlist; \
369                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
370                 echo "DONE"; \
371         fi; \
372         if [ -n "$archiveslist" ]; then \
373                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
374                 chmod u+w $archiveslist; \
375                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
376                 echo "DONE"; \
377         fi; \
378 fi; }; __spec_install_post_strip } } }
379
380 #-----------------------------------------------------------------
381 # remove all RPATH from executable binaries and shared object files
382 #
383 # Requires: find, awk, cut, xargs, chrpath, uname
384 #
385 #%no_install_post_chrpath       1
386 %__spec_install_post_chrpath {%{!?debug: \
387 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
388 if [ -d "$RPM_BUILD_ROOT" ]; then \
389 echo "Remove RPATH from executable binaries and shared object files."; \
390 find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
391         awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1 | \
392 while read file ; do \
393         rpath= ; \
394         chmod u+w "$file"; \
395         for dir in `chrpath -l "$file" | \
396                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
397                         case $dir in \
398                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
399                                 echo "remove-rpath: $dir in $file"; \
400                                 ;; \
401                         * ) \
402                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
403                                 else rpath="$rpath:$dir" ; fi ; \
404                                 ;; \
405                         esac ; \
406         done ; \
407         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
408         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
409 done; \
410 fi; }; __spec_install_post_chrpath } } }
411
412 #-----------------------------------------------------------------
413 # Find and gzip all kernel modules
414 #
415 # Requires: find
416 #
417 #%no_install_post_compress_modules      1
418 %__spec_install_post_compress_modules { \
419 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
420         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
421                 echo "Compress kernel modules"; \
422                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
423                 echo "$q" | xargs -r %{__gzip} -9nf; \
424                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
425                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
426                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
427         fi; \
428 }; __spec_install_post_compress_modules } }
429
430 # Remove common Perl files we don't package
431 %__spec_install_post_perl_clean {\
432 %{!?no_install_post_perl_clean: \
433 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
434 } }
435
436 #-----------------------------------------------------------------
437 # Update GConf2 schemas
438 #
439 # Requires: GConf2
440 #
441 %gconf_schema_install() \
442         umask 022; \
443         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
444         %{nil}
445
446 %gconf_schema_uninstall() \
447 if [ $1 = 0 ]; then \
448         umask 022; \
449         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
450 fi \
451 %{nil}
452
453 #-----------------------------------------------------------------
454 # Update desktop MIME database
455 # requires: desktop-file-utils
456 #
457 %update_desktop_database_post() {{ \
458         umask 022; \
459         /usr/bin/update-desktop-database -q; \
460 }}
461
462 %update_desktop_database_postun() {{ \
463 if [ $1 = 0 ]; then \
464         umask 022; \
465         /usr/bin/update-desktop-database -q; \
466 fi \
467 }}
468
469 #-----------------------------------------------------------------
470 # Update shared MIME info database
471 # requires: shared-mime-info
472 #
473 %update_mime_database() {{ \
474         umask 022; \
475         /usr/bin/update-mime-database %{_datadir}/mime; \
476 }}
477
478 #-----------------------------------------------------------------
479 # Update icon cache
480 # requires: gtk+
481 #
482 %update_icon_cache() {{ \
483         umask 022; \
484         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
485 }}
486
487 #-----------------------------------------------------------------
488 # Update scrollkeeper database
489 # requires: scrollkeeper
490 #
491 %scrollkeeper_update_post() \
492         /usr/bin/scrollkeeper-update -q; \
493         %{nil}
494
495 %scrollkeeper_update_postun() \
496 if [ $1 = 0 ]; then \
497         /usr/bin/scrollkeeper-update -q; \
498 fi \
499 %{nil}
500
501 #-----------------------------------------------------------------
502 # post %install sequence:
503 # - autodeps exceptions
504 # - compress all man and info pages,
505 # - strip all ELF executables and ELF shared objects if not %debug.
506 # - compress kernel modules if any
507
508 ###################################################################
509 # Requires/Provides automation
510 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
511 #
512 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
513 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
514 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
515 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
516 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
517 #%_noautocompressdoc    %{nil}
518 #
519 %_missing_doc_files_terminate_build     1%{nil}
520 %_unpackaged_files_terminate_build      %{nil}
521 # (X)emacs support
522 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
523 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
524 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
525
526 %__php_provides %{nil}
527 %__php_requires %{nil}
528 %__perl_provides %{nil}
529 %__perl_requires %{nil}
530 %__mono_provides %{nil}
531 %__mono_requires %{nil}
532
533 # Perl specific macro definitions.
534 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
535 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
536 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
537 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
538 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
539 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
540
541 # Ruby
542 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
543 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
544 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
545 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
546 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
547 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
548 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
549 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
550
551 %php_pear_dir           /usr/share/pear
552 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
553 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
554
555 # directory where php includes are installed on system.
556 %__php_includedir               /usr/include/php
557 # extract php/zend api versions
558 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
559 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
560 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
561 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
562 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
563 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
564 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
565
566 # helper macro
567 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
568
569 # macros for public use
570 # for php extensions (php-pecl)
571 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
572 %{__php_api_requires zend_module_api} \
573 %{__php_api_requires -v %php_major_version debug php_debug} \
574 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
575
576 # for zend extensions
577 %requires_zend_extension %{__php_api_requires zend_module_api} \
578 %{__php_api_requires zend_extension_api} \
579 %{__php_api_requires -v %php_major_version debug php_debug} \
580 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
581
582 # for php pdo modules (php-pecl-PDO_*)
583 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
584
585 # for using PHP post scripts. for PHP >= 5.0
586 %php_webserver_restart \
587 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
588 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
589 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
590         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
591         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
592                 %service -q php-fcgi restart \
593         fi \
594 fi \
595 %{nil}
596
597 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
598 %php4_webserver_restart \
599 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
600 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
601 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
602         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
603         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
604                 %service -q php-fcgi restart \
605         fi \
606 fi \
607 %{nil}
608
609 # Python specific macro definitions.
610 # python main version
611 %py_ver                 %(python -c "import sys; print sys.version[:3]")
612
613 # directories
614 %py_prefix              %(python -c "import sys; print sys.prefix")
615 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
616 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
617 %py_incdir              /usr/include/python%{py_ver}
618 %py_sitedir             %{py_libdir}/site-packages
619 %py_sitescriptdir %{py_scriptdir}/site-packages
620 %py_dyndir              %{py_libdir}/lib-dynload
621
622 # pure python modules compilation
623 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
624
625 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
626
627 # Software written in Python language require Python with main version
628 %pyrequires_eq() Requires:      %1
629
630 # Hardlink binary identical .pyc and .pyo files
631 # (idea by glen <at> pld-linux <dot> org)
632 %__spec_install_post_py_hardlink {\
633 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
634 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
635         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
636         if cmp -s "$a" "$b"; then \
637                 ln -f "$a" "$b"; \
638         fi; \
639 done \
640 }; __spec_install_post_py_hardlink } }
641
642 # remove python sources, so that check-files won't complain
643 # (idea by glen <at> pld-linux <dot> org)
644 %py_postclean() \
645 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
646  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
647 done \
648 %{nil}
649
650 # depmod macro
651 %depmod() { \
652 umask 022; \
653 if [ -e /boot/System.map-%1 ]; then \
654         /sbin/depmod -a -F /boot/System.map-%1 %1; \
655 else \
656         if [ -e /boot/System.map ]; then \
657                 /sbin/depmod -a -F /boot/System.map %1; \
658         else \
659                 /sbin/depmod -a %1; \
660         fi \
661 fi; \
662 }
663
664 # XMMS specific macros
665 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
666 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
667 %xmms_version                   %(xmms-config --version 2>/dev/null)
668 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
669 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
670 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
671 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
672 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
673 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
674 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
675
676 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
677
678 # user/group checking macros
679 #
680 # Usage:
681 #       %userremove myuser
682 #
683 %userremove     /usr/lib/rpm/user_group.sh user del
684 %groupremove    /usr/lib/rpm/user_group.sh group del
685 #
686 # Usage:
687 #       if %usertestrm myuser; then
688 #               /usr/sbin/userdel -r myuser
689 # Note:
690 #       use these macros only if you need to call userdel/groupdel with
691 #       a non-standard option or take an extra action; otherwise use the
692 #       %userremove/%groupremove macros
693 #
694 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
695 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
696 # user group membership management macros
697 #
698 # Usage:
699 #       %addusertogroup myuser agroup
700 #
701 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
702
703 # banner support (useful in {pre,post}{,un} and triggers)
704 #
705 # Usage:
706 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
707 # the banner text, the banner text
708 # the banner text, and following line
709 #EOF
710 # You can use any form of here-document, <<'EOF' <<-EOT will do.
711 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
712 #
713 # -a   - append to the banner
714 # -e   - send to stderr instead of stdout
715 # -n   - no show banner (overrides -t)
716 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
717 %banner(aent:)  \
718 RPM_SCRIPTVERBOSITY=5 \
719 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
720 if [ -x /usr/bin/banner.sh ]; then \
721         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
722 else \
723         CMD="cat%{-e: >&2}" \
724 fi \
725 eval $CMD %2%{?3: %3} \
726 %nil
727
728 # useradd/groupadd macros
729 # Author: Elan Ruusamäe <glen@pld-linux.org>
730 #
731 # Usage:
732 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
733 #   [-g initial_group] [-G group[,...]] login
734 #
735 #  -u uid. REQUIRED
736 #  -g gid/group. REQUIRED
737 #  -s defaults to /bin/false
738 #  -d defaults to /usr/share/empty
739 #  -c No default
740 #  -r is accepted but ignored (it's always set)
741 #  -k skeleton dir. defaults to /usr/share/empty
742 # rpm specific flags
743 #  -P package name. defaults to %{name}
744 #
745 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
746 %{!-u:%{error:useradd: Required argument -u missing}} \
747 %{!-g:%{error:useradd: Required argument -g missing}} \
748 %{!?1:%{error:useradd: Required parameter login missing}} \
749 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
750         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
751                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
752                 exit 1 \
753         fi \
754 else \
755         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
756         /usr/sbin/useradd \\\
757                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
758                 -u %{-u*} \\\
759                 -r \\\
760                 -d %{-d*}%{!-d:/usr/share/empty} \\\
761                 -s %{-s*}%{!-s:/bin/false} \\\
762                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
763                 -g %{-g*} \\\
764                 %{-M} \\\
765                 %{-G:-G %{-G*}} \\\
766                 %{expand:%{%{#}}} 1>&2 || exit $? \
767         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
768 fi;
769
770 # Usage:
771 #   %groupadd [-P package] [-g gid] group
772 #
773 # -g gid. REQUIRED
774 #
775 # Sample:
776 #   %groupadd -P %{name}-base -g %{gid} %{name}
777
778 %groupadd(g:P:rfo)      \
779 %{!-g:%{error:groupadd: Required argument -g missing}} \
780 %{!?1:%{error:groupadd: Required parameter group missing}} \
781 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
782         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
783                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
784                 exit 1 \
785         fi \
786 else \
787         echo "Adding group %{1} GID=%{-g*}." \
788         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
789         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
790 fi;
791
792 # apache_config_{install/uninstall} macros *DEPRECATED*
793 # Author: Elan Ruusamäe <glen@pld-linux.org>
794 #
795 # You should use webapp macros instead. these are here until single piece of
796 # them is gone from specs ;)
797 #
798 # The config is installed/removed inside trigger, this means that you can any
799 # time install apache1 or apache package and the configuration file is updated.
800 # if you don't need the config for various reason for specific apache, just
801 # remove the symlink from apache config directory. the trigger will not put the
802 # config again to that version of apache. In other words the config is linked
803 # to apache config directory on first install of PACKAGE or apache.
804 #
805 # should be called in trigger body:
806 #  %triggerin -- apache1 >= 1.3.33-2
807 #  %apache_config_install -v 1
808 #
809 # Add package's apache config to apache config.
810 #
811 # Usage:
812 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
813 #
814 #  -v REQUIRED: specify apache version. can be 1 or 2.
815 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
816 #  -n OPTIONAL: specify config "slot". defaults to 99
817 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
818 #
819 # Internal macros. don't use ;).
820 # expands apache config dir by apache version at build time.
821 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
822 # expands apache service name by apache version at build time.
823 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
824
825 %apache_config_install(fv:c:n:) \
826 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
827 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
828 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
829         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
830 fi\
831 # reload apache if the config symlink is there\
832 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
833         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
834         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
835                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
836         fi\
837 fi\
838 %{nil}
839
840 # Remove package's apache config from apache config.
841 #
842 # Usage:
843 #   %apache_config_uninstall -v {1|2} -n 99
844 #
845 #  -v REQUIRED: specify apache version. can be 1 or 2.
846 #  -n OPTIONAL: specify config "slot". defaults to 99
847 %apache_config_uninstall(v:n:) \
848 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
849 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
850 # remove link if either of the packages are gone \
851 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
852         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
853                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
854                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
855                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
856                 fi \
857         fi \
858 fi \
859 %{nil}
860
861 # webapp macros
862 # Author: Elan Ruusamäe <glen@pld-linux.org>
863 #
864 # The config is installed/removed inside trigger, this means that you can any
865 # time install apache1/apache/lighttpd package and the configuration file is
866 # updated. if you don't need the config for various reason for specific
867 # webserver, just remove the symlink from config directory using webapp
868 # program. the trigger will not recreate the symlink on upgrades. In other
869 # words the config is linked to webserver config directory on first install of
870 # PACKAGE or WEBSERVER.
871 #
872 # Add package's webserver config to webserver webapps dir.
873 # Usage:
874 #   %webapp_register WEBSERVER WEBAPP
875 #
876 %webapp_register() \
877 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
878 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
879         /usr/sbin/webapp register %1 %2\
880 fi\
881 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
882 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
883         %{expand:%service -q %%1 reload}\
884 fi\
885 %{nil}
886
887 # Remove package's config from webserver webapps dir.
888 # Usage:
889 #   %webapp_register [-f] WEBSERVER WEBAPP
890 %webapp_unregister(f) \
891 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
892 # remove link if either of the packages are gone \
893 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
894         /usr/sbin/webapp unregister %1 %2\
895         %{expand:%service -q %%1 reload}\
896 fi \
897 %{nil}
898
899 # see browser-plugins.spec / template-browser-plugin.spec
900 # Author: Elan Ruusamäe <glen@pld-linux.org>
901 %nsplugin_install(d:f) { \
902 # create link if it's first install of either of the packages \
903 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
904 ( \
905 %( \
906         for file in %{*}; do \
907                 echo echo Installing $file to %{-d*}; \
908                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
909         done ) \
910 ) | ( %banner -t 5 -e %{name}-in ); fi; \
911 }
912
913 %nsplugin_uninstall(d:) { \
914 # remove link if either of the packages are gone \
915 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
916 ( \
917 %( \
918         for file in %{*}; do \
919                 echo echo Removing $file from %{-d*}; \
920                 echo "rm -f %{-d*}/$file;"; \
921         done ) \
922 ) | ( %banner -t 5 -e %{name}-un ); fi; \
923 }
924
925 # service macro.
926 # Author: Elan Ruusamäe <glen@pld-linux.org>
927 #
928 # calls usual service restart on package %post, but skips the restart if
929 # administrator has disabled automatic service restarts in either global
930 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
931 #
932 # Usage:
933 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
934 #
935 #  -q be silent when service isn't started (for scriplets restaring other package's services)
936 #
937 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
938
939
940 # java macros. based on jpackage macros.java
941 %_jvmdir                %{_libdir}/jvm
942 %_jvmjardir             %{_libdir}/jvm-exports
943 %_jvmprivdir            %{_libdir}/jvm-private
944 %_jvmlibdir             %{_libdir}/jvm
945 %_jvmdatadir            %{_datadir}/jvm
946 %_jvmsysconfdir         %{_sysconfdir}/jvm
947 # FIXME: are these used?
948 %_jvmcommonlibdir       %{_libdir}/jvm-common
949 %_jvmcommondatadir      %{_datadir}/jvm-common
950 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
951 %_jnidir                %{_libdir}/java
952 %java_home              %(unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo $JAVA_HOME)
953
954 %ant                    JAVA_HOME=%{java_home} ant
955 %jar                    %{java_home}/bin/jar
956 %java                   %(unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
957 %javac                  %{java_home}/bin/javac
958 %javadoc                %{java_home}/bin/javadoc
959
960 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
961
962 %jpackage_script() \
963 install -d $RPM_BUILD_ROOT%{_bindir}\
964 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
965 #!/bin/sh\
966 #\
967 # %{name} script\
968 # JPackage Project <http://www.jpackage.org/>\
969 \
970 # Source functions library\
971 . %{_javadir}-utils/java-functions\
972 \
973 # Source system prefs\
974 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
975     . %{_sysconfdir}/java/%{name}.conf\
976 fi\
977 \
978 # Source user prefs\
979 if [ -f $HOME/.%{name}rc ]; then\
980     . $HOME/.%{name}rc\
981 fi\
982 \
983 # Configuration\
984 MAIN_CLASS=%1\
985 BASE_FLAGS=%2\
986 BASE_OPTIONS=%3\
987 BASE_JARS="%(echo %4 | tr ':' ' ')"\
988 \
989 # Set parameters\
990 set_jvm\
991 set_classpath $BASE_JARS\
992 set_flags $BASE_FLAGS\
993 set_options $BASE_OPTIONS\
994 \
995 # Let's start\
996 run "$@"\
997 EOF
998
999 # PEAR install macros
1000 # Author: Elan Ruusamäe <glen@pld-linux.org>
1001 #
1002 # Usage:
1003 #       %%pear_package_setup [-a #] [-n FMT]
1004 #
1005 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1006 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1007 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1008 #
1009 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1010 # destination hierarchy. you should copy the tree to buildroot after
1011 # patching/reorganizing with %%pear_package_install.
1012 #
1013 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1014 # line endings.
1015 #
1016 # the pear install process output is recorded to install.log, you should put it
1017 # to %%doc for later debug or just for information.
1018 #
1019 # additionally additional-packages.txt is produced if it was detected that the
1020 # package has optional dependencies. the file format is suitable of displaying
1021 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1022 # automatically added for this file.
1023
1024
1025 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1026 %__pear_install_log \
1027 tee install.log \
1028 # make post message of optional packages \
1029 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1030 if [ -s optional-packages.txt ]; then \
1031         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1032 else \
1033         rm -f optional-packages.txt \
1034 fi \
1035 %{nil}
1036
1037 # command invoking pear cli
1038 %__pear /usr/bin/pear
1039
1040 # the main macro.
1041 # using this macro will append optional-packages.txt to the nocompressdoc list
1042 # as it's displayed to user after package install. and adding additional gzip
1043 # dep is just waste ;)
1044 %pear_package_setup(a:n:z) \
1045 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1046 %define builddir %{_builddir}/%{srcdir} \
1047 %setup -q -c -T -n %{srcdir} \
1048 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1049 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1050 %__pear \\\
1051         -c pearrc \\\
1052         -d doc_dir=/docs \\\
1053         -d php_dir=%{php_pear_dir} \\\
1054         -d bin_dir=%{_bindir} \\\
1055         -d data_dir=%{php_pear_dir}/data \\\
1056         -d test_dir=%{php_pear_dir}/tests \\\
1057         install \\\
1058         --packagingroot=%{builddir} \\\
1059         --offline \\\
1060         --nodeps \\\
1061         %{-f:--force} \\\
1062         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
1063 %{-z:cd ..} \
1064 cat %{-z:$_N/}.install.log | %__pear_install_log \
1065 \
1066 # undos sources \
1067 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1068 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1069 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1070 %{nil}
1071
1072 # copies exctracted PEAR package structure to buildroot.
1073 # also copies PEAR registry file.
1074 # please use this macro, for future extensions being possible.
1075 %pear_package_install() \
1076 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1077 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1078 # help the developer out a little: \
1079 if [ -f _noautoreq ]; then \
1080         echo "AutoReqdep detected:" \
1081         echo "_noautoreq $(cat _noautoreq)" \
1082 fi \
1083 %{nil}
1084
1085
1086 # Register OpenLDAP schema.
1087 # Author: Elan Ruusamäe <glen@pld-linux.org>
1088 #
1089 # Usage:
1090 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1091 #
1092 #  -d specify dependant schemas, separated by comma
1093 #
1094 %openldap_schema_register(d:) \
1095 for schema in %*; do \
1096         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1097                 %{__sed} -i -e " \
1098                         /^include.*local.schema/{ \
1099                                 iinclude\\t     $schema\
1100                         } \
1101                 " /etc/openldap/slapd.conf \
1102         fi \
1103 done \
1104 # enable dependant schemas \
1105 if [ "%{-d*}" ]; then \
1106         %{__sed} -i -e ' \
1107         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1108                 s/^#// \
1109         }' /etc/openldap/slapd.conf \
1110 fi \
1111 %{nil}
1112
1113 # Unregister OpenLDAP schema.
1114 # Author: Elan Ruusamäe <glen@pld-linux.org>
1115 #
1116 # Usage:
1117 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1118 #
1119 %openldap_schema_unregister() \
1120 for schema in %*; do \
1121         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1122                 %{__sed} -i -e " \
1123                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1124                 # for symmetry it would be nice if we disable enabled schemas in post, \
1125                 # but we really can not do that, it would break something else. \
1126                 " /etc/openldap/slapd.conf \
1127         fi \
1128 done \
1129 %{nil}
1130
1131 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1132
1133
1134 # Build modules for kernels 2.6
1135 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1136 #
1137 # Usage:
1138 #       %build_kernel_modules -m <modules> -C <directory>
1139 #
1140 #  remember that proper Makefile is still required
1141 # Options:
1142 #  -m <modules> (required) -- comma-separated list of modules to save,
1143 #               without .ko extension, may be placed in subdirectory
1144 #  -C <directory> -- change to <directory> before doing anything
1145 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1146 #  -c -- do not execute make clean
1147 #  <additional arguments> -- all additional arguments will be passed to
1148 #               make modules
1149 #
1150 # Additional patching supported via here document. Try:
1151 #       %build_kernel_modules -m module <<'EOF'
1152 #       your patch script here
1153 #       EOF
1154 # Don't use it unless patching depends on config options.
1155
1156 # Developer note: don't touch it unless you know how to handle '\'.
1157 # - \ in script expands to nothing
1158 # - \\\ in script expands to \
1159 # - \\\ inside definition expands to noting
1160 # - \\\\\\\ inside definition expands to \
1161 # - in last line \ has to touch arguments so arguments passing
1162 #   in new lines (using \) will be supported
1163
1164 %build_kernel_modules(p:P:m:C:c)                                                                        \
1165 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1166                                                                                                                                         \
1167 %define Opts                                                                                                            \\\\\\\
1168 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1169         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1170         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1171         %else                                                                                                                   \\\
1172         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1173         %endif                                                                                                                  \\\
1174 %else                                                                                                                           \\\
1175         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1176 %endif                                                                                                                          \
1177 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1178                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1179                                                                                                                                         \
1180 %{?-C:cd %{-C*}}                                                                                                        \
1181 compile() {                                                                                                                     \
1182         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1183         set -e -x                                                                                                               \
1184                                                                                                                                         \
1185 for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}; do \
1186         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1187                                                                                                                                         \
1188         rm -rf o                                                                                                                \
1189         install -d o/include/linux                                                                              \
1190         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1191         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1192         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1193 %ifarch ppc ppc64                                                                                                       \
1194         install -d o/include/asm                                                                                \
1195         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -sf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm    \
1196         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -snf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1197 %else                                                                                                                           \
1198         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1199 %endif                                                                                                                          \
1200                                                                                                                                         \
1201         set +x                                                                                                                  \
1202         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1203         set -x                                                                                                                  \
1204                                                                                                                                         \
1205         %if %{with dist_kernel}                                                                                 \
1206                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1207                         %{-p*} %{-P*}                                                                                   \\\
1208                         %{MakeOpts}                                                                                             \
1209         %else                                                                                                                   \
1210                 install -d o/include/config                                                                     \
1211                 touch o/include/config/MARKER                                                           \
1212                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1213         %endif                                                                                                                  \
1214                                                                                                                                         \
1215         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1216                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1217                 M=$PWD %{MakeOpts}}                                                                                     \
1218         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1219                 ${1+"$@"}                                                                                                       \\\
1220                 M=$PWD %{MakeOpts}                                                                                      \
1221                                                                                                                                         \
1222         for MODULE in {%{-m*},}; do                                                                             \
1223                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1224         done                                                                                                                    \
1225 done                                                                                                                            \
1226 %{?-C:cd -}                                                                                                                     \
1227 }                                                                                                                                       \
1228 compile %{*}\
1229 %{nil}
1230
1231
1232 # Install kernel modules built by %build_kernel_modules
1233 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1234 #
1235 # Usage:
1236 #       %install_kernel_modules -m <modules> -d <directory>
1237 #
1238 # Options:
1239 #  -m <modules> (required) -- comma-separated list of modules to install,
1240 #               without .ko extension, may be placed in subdirectory
1241 #  -d <directory> (required) -- in what subdirectory modules should be
1242 #               installed (eg. misc, kernel/drivers/net)
1243 #  -s <suffix> -- suffix to use when installing modules, useful when module
1244 #               with same name exists in kernel already
1245 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1246 #               for definig aliases, only useful with -s
1247
1248 %install_kernel_modules(m:d:s:n:)                                                                       \
1249 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1250 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1251 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1252                                                                                                                                         \
1253 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1254 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1255                                                                                                                                         \
1256 install -d %{KernelD}{,smp}/%{-d*}                                                                      \
1257 %{?-s:install -d %{ModprobeD}{,smp}}                                                            \
1258                                                                                                                                         \
1259 for MODULE in {%{-m*},}; do                                                                                     \
1260         [ -n "${MODULE}" ] || continue                                                                  \
1261         MNAME=${MODULE##*/}                                                                                             \
1262         install ${MODULE}-%{?with_dist_kernel:up}%{!?with_dist_kernel:nondist}.ko \\\
1263                 %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                                      \
1264         %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
1265                 >> %{ModprobeD}/%{-n*}.conf}                                                            \
1266     %if %{with smp} && %{with dist_kernel}                                                      \
1267         install ${MODULE}-smp.ko                                                                                \\\
1268                 %{KernelD}smp/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                           \
1269         %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
1270                 >> %{ModprobeD}smp/%{-n*}.conf}                                                         \
1271     %endif                                                                                                                      \
1272 done                                                                                                                            \
1273 %{nil}
1274
1275 # patchset macros
1276 # Author: Elan Ruusamäe <glen@pld-linux.org>
1277 #
1278 # Usage:
1279 #   %patchset_source -f <seq(1) format> <start> [<end>]
1280 #   %patchset_patch <start> [<end>]
1281 #
1282 # If <end> is omited, it is assumed to be <start>.
1283 #
1284 # For example in preamble:
1285 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1286 # and in %prep:
1287 #  %patchset_patch 33 44
1288
1289 # generate SourceX urls from range START STOP
1290 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1291 # The sources start from 10000
1292 %patchset_source(x:f:) %(\
1293         seq -f 'Patch10%03g:' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps1; \
1294         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2; \
1295         paste %{tmpdir}/__ps{1,2}; \
1296         rm -f %{tmpdir}/__ps{1,2}; \
1297 ) \
1298 %{nil}
1299
1300 # apply sources from %patchset_source
1301 # -p specify -pX for %patch line
1302 # -b base offset: defaults to 10000
1303 %patchset_patch(f:p:b:) %(
1304         echo ": patchset_patch %1%{?2: to %2}"; \
1305         seq -f '%g=%{-p*:-p%{-p*}}' %1 %{?2}%{!?2:%{1}} | \
1306         awk -vbase=%{-b*}%{!-b*:10000} -F= '{printf(": patchset %d\\n%%%%patch%d %s\\n", $1, $1+base, $2)}'; \
1307 ) \
1308 %{nil}
1309
1310 # vim:ts=4 sw=4 noet syn=spec
This page took 0.344624 seconds and 4 git commands to generate.